
/* 	Persona 4: DAN & Persona 5 model and animation importer (*.gmd; *.gfs; *.gap) written in MaxScript
	Version 0.8.1
	Script by TGE. Please give credit where is due.
	Special thanks to PolarSoda, mrdudesworkshop
*/
		
-- Magic values
GFSFileMagic						= 0x47465330
GFSChunkVersion					= 0x01105070 -- not constant
GFSTextureFooterMagic 		= 0x01010000

-- Chunk types
GFSChunkTypeFileEnd 					= 0
GFSChunkTypeFileStart 				= 1
GFSChunkTypeScene 					= 0x00010003
GFSChunkTypeMaterialList				= 0x000100FB
GFSChunkTypeTextureList				= 0x000100FC
GFSChunkTypeAnimationGroup 		= 0x000100FD

-- Material texture slot ids
GFSMaterialDiffuseTextureSlotID		= 1
GFSMaterialNormalTextureSlotID		= 2
GFSMaterialSpecularTextureSlotID	= 3
GFSMaterialReflectionTextureSlotID	= 4
GFSMaterialHighlightTextureSlotID	= 5
GFSMaterialGlowTextureSlotID 		= 6
GFSMaterialNightTextureSlotID 		= 7
GFSMaterialDetailTextureSlotID 		= 8
GFSMaterialShadowTextureSlotID 	= 9
GFSMaterialTextureSlot10ID 			= 10
GFSMaterialTextureSlot11ID 			= 11
GFSMaterialTextureSlot12ID 			= 12
GFSMaterialTextureSlotCount			= 9

-- Material flags
GFSMaterialFlags1									= 0x00000001 -- bit 0
GFSMaterialFlags2									= 0x00000002 -- bit 1
GFSMaterialFlags3									= 0x00000004 -- bit 2
GFSMaterialFlags4									= 0x00000008 -- bit 3
GFSMaterialFlags5									= 0x00000010 -- bit 4
GFSMaterialFlags6									= 0x00000020 -- bit 5
GFSMaterialFlags7									= 0x00000040 -- bit 6
GFSMaterialFlags8									= 0x00000080 -- bit 7
GFSMaterialFlags9									= 0x00000100 -- bit 8
GFSMaterialFlags10									= 0x00000200 -- bit 9
GFSMaterialFlags11									= 0x00000400 -- bit 10
GFSMaterialFlags12									= 0x00000800 -- bit 11
GFSMaterialFlags13									= 0x00001000 -- bit 12
GFSMaterialFlags14									= 0x00002000 -- bit 13
GFSMaterialFlags15									= 0x00004000 -- bit 14
GFSMaterialFlags16									= 0x00008000 -- bit 15
GFSMaterialFlags17									= 0x00010000 -- bit 16
GFSMaterialFlags18									= 0x00020000 -- bit 17
GFSMaterialFlags19									= 0x00040000 -- bit 18
GFSMaterialFlags20									= 0x00080000 -- bit 19
GFSMaterialFlagsUseDiffuseTextureSlot		= 0x00100000 -- bit 20
GFSMaterialFlagsUseNormalTextureSlot			= 0x00200000 -- bit 21
GFSMaterialFlagsUseSpecularTextureSlot		= 0x00400000 -- bit 22
GFSMaterialFlagsUseReflectionTextureSlot	= 0x00800000 -- bit 23
GFSMaterialFlagsUseHighlightTextureSlot		= 0x01000000 -- bit 24
GFSMaterialFlagsUseGlowTextureSlot			= 0x02000000 -- bit 25
GFSMaterialFlagsUseNightTextureSlot			= 0x04000000 -- bit 26
GFSMaterialFlagsUseDetailTextureSlot			= 0x08000000 -- bit 27
GFSMaterialFlagsUseShadowTextureSlot		= 0x10000000 -- bit 28
GFSMaterialFlagsUseTextureSlot10				= 0x20000000 -- bit 29
GFSMaterialFlagsUseTextureSlot11				= 0x40000000 -- bit 30
GFSMaterialFlagsUseTextureSlot12				= 0x80000000 -- bit 31

GFSMaterialFlagsTextureSlotNames = #
(
	"DiffuseTextureSlot",
	"NormalTextureSlot",
	"SpecularTextureSlot",
	"ReflectionTextureSlot",
	"HighlightTextureSlot",
	"GlowTextureSlot",
	"NightTextureSlot",
	"DetailTextureSlot",
	"ShadowTextureSlot",
	"Tex10",
	"Tex11",
	"Tex12",
	"Tex13"
)

-- Scene flags
GFSSceneFlagsHasBBox		= 0x00000001 -- or 0x00000002
GFSSceneFlagsSkinned		= 0x00000004
GFSSceneFlagsMorphed		= 0x00000008

-- Node user property types
GFSNodeUserPropertyTypeNone	= 0
GFSNodeUserPropertyTypeInt		= 1
GFSNodeUserPropertyTypeFloat	= 2
GFSNodeUserPropertyTypeBool	= 3
GFSNodeUserPropertyTypeString	= 4

-- Mesh FVF flags
GFSMeshFVFPosition 	= 0x00000000
GFSMeshFVFUnknown2 	= 0x00000001	-- Bit 0
GFSMeshFVFNormal 		= 0x00000002	-- Bit 1
GFSMeshFVFUnknown4 	= 0x00000004	-- Bit 2
GFSMeshFVFUnknown5 	= 0x00000008	-- Bit 3
GFSMeshFVFUnknown6 	= 0x00000010 -- Bit 4, No data
GFSMeshFVFUnknown7 	= 0x00000020	-- Bit 5
GFSMeshFVFColor 		= 0x00000040	-- Bit 6
GFSMeshFVFUnknown9	= 0x00000080	-- Bit 7
GFSMeshFVFTex1 		= 0x00000100	-- Bit 8
GFSMeshFVFTex2 		= 0x00000200	-- Bit 9
GFSMeshFVFTex3 		= 0x00000400	-- Bit 10
GFSMeshFVFTex4 		= 0x00000800	-- Bit 11
GFSMeshFVFTex5 		= 0x00001000	-- Bit 12
GFSMeshFVFTex6 		= 0x00002000	-- Bit 13
GFSMeshFVFTex7 		= 0x00004000	-- Bit 14
GFSMeshFVFTex8 		= 0x00008000	-- Bit 15
GFSMeshFVFTangent 	= 0x10000000	-- Bit 28 (guess)

-- Struct declarations
struct GFSChunkDescriptor
(
	StartOffset,
	Version,
	Type,
	Size
)

struct GFSAnimationGroup
(
	Field1,
	Flags,
	AnimationCount,
	Animations = #()
)

struct GFSAnimation
(
	Flags,
	Duration,
	ControllerCount,
	Controllers = #()
)

struct GFSAnimationPRSController
(
	Type,
	NodeID,
	NodeName,
	NodeHash,
	Field2,
	KeyFrameFlags,
	KeyFrameCount,
	KeyFrameTimings = #(),
	KeyFrames = #(),
	BasePosition,
	BaseScale
)

struct GFSAnimationMaterialController
(
	Type,
	MaterialID,
	MaterialName,
	MaterialHash,
	Field2,
	KeyFrameFlags,
	KeyFrameCount,
	KeyFrameTimings = #(),
	KeyFrames = #()
)

struct GFSAnimationCameraController
(
	Type,
	CameraID,
	CameraName,
	CameraHash,
	Field2,
	KeyFrameFlags,
	KeyFrameCount,
	KeyFrameTimings = #(),
	KeyFrames = #()
)

struct GFSAnimationMorphController
(
	Type,
	NodeID,
	NodeName,
	NodeHash,
	Field2,
	KeyFrameFlags,
	KeyFrameCount,
	KeyFrameTimings = #(),
	KeyFrames = #()
)

struct GFSAnimationKeyFramePRS
(
	Position,
	Rotation,
	Scale
)

struct GFSAnimationKeyFramePR
(
	Position,
	Rotation
)

struct GFSTexture
(
	Name,
	PixelFormat,
	DataLength
)

struct GFSMaterial
(
	Name,
	Hash,
	Flags,
	FloatFields = #(),
	ShortFields = #(),
	UintFields = #(),
	ShortField,
	UintField,
	TextureSlots = #()	
)

struct GFSMaterialTextureSlot
(
	TextureName,
	Hash
)

struct GFSScene
(
	Field0,
	Flags,
	UsedBoneCount,
	InvBindMatrices = #(),
	UsedBoneMap = #(),
	Nodes = #()
)

struct GFSNode
(
	Parent,
	Name,
	Hash,
	Position,
	Rotation,
	Scale,
	AttachmentCount,
	Attachments = #(),
	ChildCount,
	Children = #(),
	MaxBoneNode,
	UserProperties = #()
)

struct GFSNodeAttachment
(
	Type,
	Object
)

struct GFSNodeUserProperty
(
	Type,
	Key,
	Hash,
	Size,
	Value
)

struct GFSMesh
(
	Flags,
	VertexFormat,
	FaceCount,
	Field5,
	VertexCount,
	Field7,
	VertexPositions = #(),
	VertexNormals = #(),
	VertexTangents = #(),
	VertexColors = #(),
	VertexWeights = #(),
	VertexWeightIndices = #(),
	VertexTexCoordChannels = #(#(), #(), #(), #(), #(), #(), #(), #()),
	FaceIndices = #(),
	MaterialName,
	MaterialHash,
	MaxMeshNode
)

struct GFSFile
(
	Textures,
	Materials,
	Scene,
	AnimationGroup
)
