
/* 	Persona 4: DAN & Persona 5 model and animation importer (*.gmd; *.gfs; *.gap) written in MaxScript
	Version 0.8.1
	Script by TGE. Please give credit where is due.
	Special thanks to PolarSoda, mrdudesworkshop
*/

FileIn "include\\MaxScriptExtensions\\FileUtils.ms"
FileIn "include\\GFSFileLoader.ms"

GC()
ClearListener()

global g_FilePath = FileUtils.RunOpenFileDialog "Open model or animation file" "Persona 5 Model (*.gmd; *.gfs; *.gap)|*.gmd; *.gfs; *.gap" "P5 Object Presets"
if (g_FilePath != undefined) then
(
	if (not (GFSFileLoader.IsValidFile(g_FilePath))) then
	(
		Format "Not a valid Persona 5 model file. (File doesn't start with GFS0 signature)\n"
	)
	else
	(
		local gfsLoader = GFSFileLoader()

		try (		
		with redraw off
		(
			/* Configure loader options */
			gfsLoader.SetFile(g_FilePath)
			gfsLoader.ApplyNormals = true
			gfsLoader.ApplyColors = true
			gfsLoader.ApplySkin = true
			gfsLoader.ApplyYToZUp = true
			gfsLoader.OverwriteExistingTextures = false
			gfsLoader.ExportTexturesOnly = false
			gfsLoader.LoadAnimationOnly = false
			gfsLoader.Load()
		)
		
		Format "File loaded successfully.\n"
		) catch (Print (getCurrentException()))
		
		-- Clean up, not that it will help much
		GC()
		GC()
	)
)
